unit rutinok;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls;

type

  { Tgrafikak }

  Tgrafikak = class(TForm)
    bili: TButton;
    Label1: TLabel;
    vege: TButton;
    dombok: TButton;
    hegy: TButton;
    virag: TButton;
    szikla: TButton;
    szakadek: TButton;
    miller: TButton;
    hipopeda: TButton;
    torles: TButton;
    rajzlap: TImage;
    procedure biliClick(Sender: TObject);
    procedure dombokClick(Sender: TObject);
    procedure hegyClick(Sender: TObject);
    procedure hipopedaClick(Sender: TObject);
    procedure millerClick(Sender: TObject);
    procedure szakadekClick(Sender: TObject);
    procedure sziklaClick(Sender: TObject);
    procedure torlesClick(Sender: TObject);
    procedure vegeClick(Sender: TObject);
    procedure viragClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  grafikak: Tgrafikak;

implementation

{$R *.lfm}

{ Tgrafikak }

procedure Tgrafikak.vegeClick(Sender: TObject);
begin
  Close
end;

procedure Tgrafikak.viragClick(Sender: TObject);
const
   rg=100;
   dx=1/(rg+1);
   dy=1/(rg+1);
   zrel=0.5;

var
   ix,iy,i:integer;
   x,y:real;
   takar:array[-rg..rg] of integer;
   mx,my:integer;
   maxx,maxy:integer;

function fuggveny(x,y:real):real;

var
   d:real;

begin
   x:=32*x-16;
   y:=32*y-16;
   if sqr(x)+sqr(y)>12.25
      then d:=x/5*cos(2*pi*y/x)
      else d:=0.5*sqrt(12.25-sqr(x)-sqr(y));
   fuggveny:=d/10+0.5
end;

procedure movep(x,y,z:real);
var xx,yy,tt:integer;
begin
   xx:=round(mx*(1+x-y));
   yy:=round(my*(2+zrel-x-y-z*zrel));
   tt:=round((x-y)*rg);
   if takar[tt]<yy
   then
      rajzlap.Canvas.moveto(xx,takar[tt])
   else begin
      rajzlap.Canvas.moveto(xx,yy);
      takar[tt]:=yy;
   end;
end;

procedure draw(x,y,z:real);

var
   xx,yy,tt:integer;

begin
   xx:=round(mx*(1+x-y));
   yy:=round(my*(2+zrel-x-y-z*zrel));
   tt:=round((x-y)*rg);
   if takar[tt]<yy
   then
      rajzlap.Canvas.lineto(xx,takar[tt])
   else begin
      rajzlap.Canvas.lineto(xx,yy);
      takar[tt]:=yy
   end;
end;

begin
   rajzlap.Canvas.FillRect(rajzlap.ClientRect);
   rajzlap.Canvas.TextOut(8,8,'Virag');
   maxx:=800;
   maxy:=800;
   mx:=trunc(maxx/2);
   my:=trunc(maxy/(2+zrel));

   for i:=-rg to rg
      do takar[i]:=maxy;

   x:=0;
   for ix:=0 to rg do begin
      y:=0;
      movep(x,y,fuggveny(x,0));
      for iy:=1 to rg do begin
         y:=y+dy;
         draw(x,y,fuggveny(x,y))
      end;
      x:=x+dx
   end;

   for i:=-rg to rg
      do takar[i]:=maxy;

   y:=0;
   for iy:=0 to rg do begin
      x:=0;
      movep(x,y,fuggveny(0,y));
      for ix:=1 to rg do begin
         x:=x+dx;
         draw(x,y,fuggveny(x,y))
      end;
      y:=y+dy
   end;
end;

procedure Tgrafikak.torlesClick(Sender: TObject);
begin
   rajzlap.Canvas.brush.color:=clMaroon;
   rajzlap.Canvas.pen.color:=clYellow;
   rajzlap.Canvas.FillRect(rajzlap.ClientRect);
   rajzlap.Canvas.Font.Color:=clWhite;
   rajzlap.Canvas.Font.Size:=16;
end;

procedure Tgrafikak.biliClick(Sender: TObject);
const
   rg=100;
   dx=1/(rg+1);
   dy=1/(rg+1);
   zrel=0.5;

var
   mx,my:integer;
   maxx,maxy:integer;
   ix,iy,i:integer;
   x,y:real;
   takar:array[-rg..rg] of integer;

function fuggveny(x,y:real):real;

var
   d:real;

begin
   x:=40*x-20;
   y:=40*y-20;
   d:=7*sin(pi/7*sqrt(sqr(x)+sqr(y)))*7;
   fuggveny:=d/100+0.5
end;

procedure movep(x,y,z:real);
var xx,yy,tt:integer;
begin
   xx:=round(mx*(1+x-y));
   yy:=round(my*(2+zrel-x-y-z*zrel));
   tt:=round((x-y)*rg);
   if takar[tt]<yy
   then
      rajzlap.Canvas.moveto(xx,takar[tt])
   else begin
      rajzlap.Canvas.moveto(xx,yy);
      takar[tt]:=yy;
   end;
end;

procedure draw(x,y,z:real);

var
   xx,yy,tt:integer;

begin
   xx:=round(mx*(1+x-y));
   yy:=round(my*(2+zrel-x-y-z*zrel));
   tt:=round((x-y)*rg);
   if takar[tt]<yy
   then
      rajzlap.Canvas.lineto(xx,takar[tt])
   else begin
      rajzlap.Canvas.lineto(xx,yy);
      takar[tt]:=yy
   end;
end;

begin
   rajzlap.Canvas.FillRect(rajzlap.ClientRect);
   rajzlap.Canvas.TextOut(8,8,'Bili');
   maxx:=800;
   maxy:=800;
   mx:=trunc(maxx/2);
   my:=trunc(maxy/(2+zrel));

   for i:=-rg to rg
      do takar[i]:=maxy;

   x:=0;
   for ix:=0 to rg do begin
      y:=0;
      movep(x,y,fuggveny(x,0));
      for iy:=1 to rg do begin
         y:=y+dy;
         draw(x,y,fuggveny(x,y))
      end;
      x:=x+dx
   end;

   for i:=-rg to rg
      do takar[i]:=maxy;

   y:=0;
   for iy:=0 to rg do begin
      x:=0;
      movep(x,y,fuggveny(0,y));
      for ix:=1 to rg do begin
         x:=x+dx;
         draw(x,y,fuggveny(x,y))
      end;
      y:=y+dy
   end;
end;

procedure Tgrafikak.dombokClick(Sender: TObject);
const
   rg=100;
   dx=1/(rg+1);
   dy=1/(rg+1);
   zrel=1.0;

var
   mx,my:integer;
   maxx,maxy:integer;
   ix,iy,i:integer;
   x,y:real;
   takar:array[-rg..rg] of integer;

function fuggveny(x,y:real):real;

var
   f1,f2:real;

begin
   f1:=30*sqrt(sqr(x-0.4)+sqr(y-0.9));
   if f1<1E-5
      then f1:=1
      else f1:=sin(f1)/f1;
   f2:=30*sqrt(sqr(x-0.8)+sqr(y-0.4));
   if f2<1E-5
      then f2:=1
      else f2:=sin(f2)/f2;
   fuggveny:=f1+f2;
end;

procedure movep(x,y,z:real);
var xx,yy,tt:integer;
begin
   xx:=round(mx*(1+x-y));
   yy:=round(my*(2+zrel-x-y-z*zrel));
   tt:=round((x-y)*rg);
   if takar[tt]<yy
   then
      rajzlap.Canvas.moveto(xx,takar[tt])
   else begin
      rajzlap.Canvas.moveto(xx,yy);
      takar[tt]:=yy;
   end;
end;

procedure draw(x,y,z:real);

var
   xx,yy,tt:integer;

begin
   xx:=round(mx*(1+x-y));
   yy:=round(my*(2+zrel-x-y-z*zrel));
   tt:=round((x-y)*rg);
   if takar[tt]<yy
   then
      rajzlap.Canvas.lineto(xx,takar[tt])
   else begin
      rajzlap.Canvas.lineto(xx,yy);
      takar[tt]:=yy
   end;
end;

begin
   rajzlap.Canvas.FillRect(rajzlap.ClientRect);
   rajzlap.Canvas.TextOut(8,8,'Dombok');
   maxx:=800;
   maxy:=800;
   mx:=trunc(maxx/2);
   my:=trunc(maxy/(2+zrel));

   for i:=-rg to rg
      do takar[i]:=maxy;

   x:=0;
   for ix:=0 to rg do begin
      y:=0;
      movep(x,y,fuggveny(x,0));
      for iy:=1 to rg do begin
         y:=y+dy;
         draw(x,y,fuggveny(x,y))
      end;
      x:=x+dx
   end;

   for i:=-rg to rg
      do takar[i]:=maxy;

   y:=0;
   for iy:=0 to rg do begin
      x:=0;
      movep(x,y,fuggveny(0,y));
      for ix:=1 to rg do begin
         x:=x+dx;
         draw(x,y,fuggveny(x,y))
      end;
      y:=y+dy
   end;
end;

procedure Tgrafikak.hegyClick(Sender: TObject);

const
   rg=100;
   dx=1/(rg+1);
   dy=1/(rg+1);
   zrel=1.0;

var
   ix,iy,i:integer;
   x,y:real;
   takar:array[-rg..rg] of integer;
   mx,my:integer;
   maxx,maxy:integer;

function fuggveny(x,y:real):real;

var
   d:real;
begin
   x:=2*x-1;
   y:=2*y-1;
   d:=5*(sqrt(x*x+y*y));
   fuggveny:=(sin(d)-sin(3*d)/3+sin(5*d)/5)/d
end;

procedure movep(x,y,z:real);
var xx,yy,tt:integer;
begin
   xx:=round(mx*(1+x-y));
   yy:=round(my*(2+zrel-x-y-z*zrel));
   tt:=round((x-y)*rg);
   if takar[tt]<yy
   then
      rajzlap.Canvas.moveto(xx,takar[tt])
   else begin
      rajzlap.Canvas.moveto(xx,yy);
      takar[tt]:=yy;
   end;
end;

procedure draw(x,y,z:real);

var
   xx,yy,tt:integer;

begin
   xx:=round(mx*(1+x-y));
   yy:=round(my*(2+zrel-x-y-z*zrel));
   tt:=round((x-y)*rg);
   if takar[tt]<yy
   then
      rajzlap.Canvas.lineto(xx,takar[tt])
   else begin
      rajzlap.Canvas.lineto(xx,yy);
      takar[tt]:=yy
   end;
end;

begin
   rajzlap.Canvas.FillRect(rajzlap.ClientRect);
   rajzlap.Canvas.TextOut(8,8,'Hegy');
   maxx:=800;
   maxy:=800;
   mx:=trunc(maxx/2);
   my:=trunc(maxy/(2+zrel));

   for i:=-rg to rg
      do takar[i]:=maxy;

   x:=0;
   for ix:=0 to rg do begin
      y:=0;
      movep(x,y,fuggveny(x,0));
      for iy:=1 to rg do begin
         y:=y+dy;
         draw(x,y,fuggveny(x,y))
      end;
      x:=x+dx
   end;

   for i:=-rg to rg
      do takar[i]:=maxy;

   y:=0;
   for iy:=0 to rg do begin
      x:=0;
      movep(x,y,fuggveny(0,y));
      for ix:=1 to rg do begin
         x:=x+dx;
         draw(x,y,fuggveny(x,y))
      end;
      y:=y+dy
   end;
end;

procedure Tgrafikak.hipopedaClick(Sender: TObject);
var
   a,b,i,k,x,y:real;

begin
   rajzlap.Canvas.FillRect(rajzlap.ClientRect);
   rajzlap.Canvas.TextOut(8,8,'Hipopéda');
   a:=20;
   b:=20;
   repeat
      i:=-400;
      repeat
         k:=abs((a*b)-(sqr(b)*sqr(sin(pi/180*i))));
         k:=sqrt(k);
         x:=5*cos(pi/180*i)*k+400;
         y:=5*sin(pi/180*i)*k+400;
         if i=-400 then rajzlap.Canvas.moveto(trunc(x),trunc(y)) else rajzlap.Canvas.lineto(trunc(x),trunc(y));
         i:=i+1;
      until (i>400);
      a:=a+4;
   until (a>320);
end;

procedure Tgrafikak.millerClick(Sender: TObject);
var
   x,y,t:real;
   i:integer;

begin
   rajzlap.Canvas.FillRect(rajzlap.ClientRect);
   rajzlap.Canvas.TextOut(8,8,'Miller');
   for i:=0 to 40000 do begin
      t:=pi/180*i;
      x:=200*(sin(0.99*t)-(0.7*cos(3.01*t)))+400;
      y:=300*(cos(1.01*t)+(0.1*sin(15.03*t)))+400;
      if i=0 then rajzlap.Canvas.moveto(trunc(x),trunc(y)) else rajzlap.Canvas.lineto(trunc(x),trunc(y));
   end;
end;

procedure Tgrafikak.szakadekClick(Sender: TObject);
const
   rg=50;
   dx=1/(rg+1);
   dy=1/(rg+1);
   zrel=1.0;

var
   ix,iy,i:integer;
   x,y:real;
   takar:array[-rg..rg] of integer;
   mx,my:integer;
   maxx,maxy:integer;

function fuggveny(x,y:real):real;

var
   fx,fy,xx:real;
   n:byte;

begin
   if (x=0) or (y=0) then fuggveny:=0
   else begin
      fx:=x*4-2;
      fy:=y*4-2;
      n:=0;
      while (n<50) and ((fx*fx)+(fy*fy)<4) do begin
         xx:=(fx*fx)-(fy*fy)+(x*4-2);
         fy:=2*fx*fy+(y*4-2);
         fx:=xx;
         n:=n+1;
      end;
      fuggveny:=1-(n/50);
   end;
end;

procedure movep(x,y,z:real);
var xx,yy,tt:integer;
begin
   xx:=round(mx*(1+x-y));
   yy:=round(my*(2+zrel-x-y-z*zrel));
   tt:=round((x-y)*rg);
   if takar[tt]<yy
   then
      rajzlap.Canvas.moveto(xx,takar[tt])
   else begin
      rajzlap.Canvas.moveto(xx,yy);
      takar[tt]:=yy;
   end;
end;

procedure draw(x,y,z:real);

var
   xx,yy,tt:integer;

begin
   xx:=round(mx*(1+x-y));
   yy:=round(my*(2+zrel-x-y-z*zrel));
   tt:=round((x-y)*rg);
   if takar[tt]<yy
   then
      rajzlap.Canvas.lineto(xx,takar[tt])
   else begin
      rajzlap.Canvas.lineto(xx,yy);
      takar[tt]:=yy
   end;
end;

begin
   rajzlap.Canvas.FillRect(rajzlap.ClientRect);
   rajzlap.Canvas.TextOut(8,8,'Szakadék');
   maxx:=800;
   maxy:=800;
   mx:=trunc(maxx/2);
   my:=trunc(maxy/(2+zrel));

   for i:=-rg to rg
      do takar[i]:=maxy;

   x:=0;
   for ix:=0 to rg do begin
      y:=0;
      movep(x,y,fuggveny(x,0));
      for iy:=1 to rg do begin
         y:=y+dy;
         draw(x,y,fuggveny(x,y))
      end;
      x:=x+dx
   end;

   for i:=-rg to rg
      do takar[i]:=maxy;

   y:=0;
   for iy:=0 to rg do begin
      x:=0;
      movep(x,y,fuggveny(0,y));
      for ix:=1 to rg do begin
         x:=x+dx;
         draw(x,y,fuggveny(x,y))
      end;
      y:=y+dy
   end;
end;

procedure Tgrafikak.sziklaClick(Sender: TObject);
const
   rg=50;
   dx=1/(rg+1);
   dy=1/(rg+1);
   zrel=1.0;

var
   ix,iy,i:integer;
   x,y:real;
   takar:array[-rg..rg] of integer;
   mx,my:integer;
   maxx,maxy:integer;

function fuggveny(x,y:real):real;

var
   fx,fy,xx:real;
   n:byte;

begin
   fx:=x*4-2;
   fy:=y*4-2;
   n:=0;
   while (n<50) and ((fx*fx)+(fy*fy)<4) do begin
      xx:=(fx*fx)-(fy*fy)+(x*4-2);
      fy:=2*fx*fy+(y*4-2);
      fx:=xx;
      n:=n+1;
   end;
   fuggveny:=n/50;
end;

procedure movep(x,y,z:real);
var xx,yy,tt:integer;
begin
   xx:=round(mx*(1+x-y));
   yy:=round(my*(2+zrel-x-y-z*zrel));
   tt:=round((x-y)*rg);
   if takar[tt]<yy
   then
      rajzlap.Canvas.moveto(xx,takar[tt])
   else begin
      rajzlap.Canvas.moveto(xx,yy);
      takar[tt]:=yy;
   end;
end;

procedure draw(x,y,z:real);

var
   xx,yy,tt:integer;

begin
   xx:=round(mx*(1+x-y));
   yy:=round(my*(2+zrel-x-y-z*zrel));
   tt:=round((x-y)*rg);
   if takar[tt]<yy
   then
      rajzlap.Canvas.lineto(xx,takar[tt])
   else begin
      rajzlap.Canvas.lineto(xx,yy);
      takar[tt]:=yy
   end;
end;

begin
   rajzlap.Canvas.FillRect(rajzlap.ClientRect);
   rajzlap.Canvas.TextOut(8,8,'Szikla');
   maxx:=800;
   maxy:=800;
   mx:=trunc(maxx/2);
   my:=trunc(maxy/(2+zrel));

   for i:=-rg to rg
      do takar[i]:=maxy;

   x:=0;
   for ix:=0 to rg do begin
      y:=0;
      movep(x,y,fuggveny(x,0));
      for iy:=1 to rg do begin
         y:=y+dy;
         draw(x,y,fuggveny(x,y))
      end;
      x:=x+dx
   end;

   for i:=-rg to rg
      do takar[i]:=maxy;

   y:=0;
   for iy:=0 to rg do begin
      x:=0;
      movep(x,y,fuggveny(0,y));
      for ix:=1 to rg do begin
         x:=x+dx;
         draw(x,y,fuggveny(x,y))
      end;
      y:=y+dy
   end;
end;


end.

